UNIT mTNetzHW;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses Windows, SysUtils, Dialogs;

type
   TNetzHW = CLASS

     // weitere Attribute
     private
        PortHandle : integer;

     // weitere Methoden
     public
        procedure SetAus (pAus: boolean); virtual;
        procedure Start (nr: byte); virtual;
        procedure Stop; virtual;
        function GetEin : boolean; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TNetzHW: Methodendefinition 
//+---------------------------------------------------------------------


//-------- SetAus (public) ---------------------------------------------
procedure TNetzHW.SetAus (pAus: boolean);
begin
  if pAus
  then
    EscapeCommFunction(PortHandle,SETRTS)
  else
    EscapeCommFunction(PortHandle,CLRRTS);   
end;

//-------- Start (public) ----------------------------------------------
procedure TNetzHW.Start (nr: byte);
var
  res,error : integer;
  PortStr   : string;
begin
  PortStr := 'COM'+IntToStr(nr);
  res := CreateFile(PChar(PortStr),
                    GENERIC_READ or GENERIC_WRITE,
                    0,nil,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,0); // gendert !!
  if res > 0
  then
  begin
    PortHandle := res;
    setAus(false);                         // RTS auf Null
    EscapeCommFunction(PortHandle,CLRDTR); // DTR auf Null
  end
  else
  begin
    error := GetLastError;
    ShowMessage('Fehler: '+IntToStr(error));
  end;
end;

//-------- Stop (public) -----------------------------------------------
procedure TNetzHW.Stop;
begin
  CloseHandle(PortHandle);
end;

//-------- GetEin (public) ---------------------------------------------
function TNetzHW.GetEin : boolean;
var
  ein : DWORD;
begin
  GetCommModemStatus(PortHandle,ein);
  result := (ein and 16) > 0; // Ausmaskieren des CTS-Bits
end;

end.
